﻿Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite.Drawing
Imports ThinkGeo.MapSuite.Layers
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Styles

Public Class CustomWMSLayer
  Inherits WmsRasterLayer
  Private WithEvents o As WmsRasterSource
  Public Sub New(oUri As Uri)
    MyBase.New(oUri)
    AddHandler CType(ImageSource, WmsRasterSource).SendingWebRequest, AddressOf o_SendingWebRequest

  End Sub
  Protected Overrides Function GetRequestUrlCore(worldExtent As RectangleShape, canvasWidth As Integer, canvasHeight As Integer) As String
    Return MyBase.GetRequestUrlCore(worldExtent, canvasWidth, canvasHeight)
  End Function
  Protected Overrides Sub DrawExceptionCore(canvas As GeoCanvas, e As Exception)
    MyBase.DrawExceptionCore(canvas, e)
  End Sub
  Protected Overrides Sub DrawCore(canvas As GeoCanvas, labelsInAllLayers As Collection(Of SimpleCandidate))
    Try

      Dim tempCanvas As PlatformGeoCanvas = canvas
      tempCanvas.DrawingQuality = DrawingQuality.CanvasSettings
      tempCanvas.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBilinear
      tempCanvas.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality
      MyBase.DrawCore(tempCanvas, labelsInAllLayers)

      'MyBase.DrawCore(canvas, labelsInAllLayers)
    Catch ex As Exception
      Debug.WriteLine(ex.Message)
    End Try

  End Sub
  Protected Overrides Sub OpenCore()
    Try
      MyBase.OpenCore()
    Catch ex As Exception
      Debug.WriteLine(ex.Message)
      Throw ex
    End Try
  End Sub

  Private Sub o_SendingWebRequest(sender As Object, e As SendingWebRequestEventArgs)
    'Dim sRequest As String = e.WebRequest.RequestUri.OriginalString
    'Dim oWebRequest As Net.WebRequest = Net.WebRequest.Create("https://nowcoast.noaa.gov/arcgis/services/nowcoast/wwa_meteocean_tropicalcyclones_trackintensityfcsts_time/MapServer/WmsServer?service=WMS&version=1.3.0&request=GetCapabilities")
    'oWebRequest.UseDefaultCredentials = True
    'e.WebRequest.RequestUri.OriginalSt = sRequest
    'e.WebRequest = oWebRequest
    Debug.WriteLine(e.WebRequest.RequestUri.AbsoluteUri)

  End Sub
End Class
