﻿Imports System.Collections.ObjectModel

Public Class CustomWmsLayerProps
  Public Property Level As Integer
  Public ReadOnly Property IsGroupLayer As Boolean
    Get
      Return (ContainedLayers IsNot Nothing) AndAlso (ContainedLayers.Count > 0)
    End Get
  End Property
  Public Property ContainedLayers As List(Of CustomWmsLayerProps)
  Public Property Title As String
  Public Property Name As String
  Public Property Abstract As String
  Public Property CrsAvailable As New Collection(Of String)
  Public Property Srid As Integer
  Public Shared Property CrsCommonToAllSelectedLayers As Dictionary(Of String, String)

  Public Sub New()

  End Sub
  Public Sub AddContainedLayer(oContainedLayer As CustomWmsLayerProps)
    If ContainedLayers Is Nothing Then
      ContainedLayers = New List(Of CustomWmsLayerProps)
    End If
    ContainedLayers.Add(oContainedLayer)
  End Sub
  Public Shared Function GetCommonCrs() As String

    Dim sReturnCrs As String = String.Empty
    For Each oKvp As KeyValuePair(Of String, String) In CrsCommonToAllSelectedLayers
      Select Case oKvp.Value
        Case "EPSG:3857"
          sReturnCrs = oKvp.Value
          Exit For
        Case "CRS:84", "EPSG:4326"
          sReturnCrs = "EPSG:4326"
          'sReturnCrs = oKvp.Value
          Exit For
      End Select
    Next oKvp

    Return sReturnCrs
  End Function
  Public Shared Sub PopulateCrsCommonToAllSelectedLayers(oWmsLayerProps As Collection(Of CustomWmsLayerProps))
    CrsCommonToAllSelectedLayers = New Dictionary(Of String, String)
    For Each oWmsProps In oWmsLayerProps
      For Each sCrs In oWmsProps.CrsAvailable
        If Not CrsCommonToAllSelectedLayers.ContainsKey(sCrs) AndAlso mAllLayersContainCrs(sCrs, oWmsLayerProps) Then
          CrsCommonToAllSelectedLayers.Add(sCrs, sCrs)
        End If
      Next sCrs
    Next oWmsProps
  End Sub
  Private Shared Function mAllLayersContainCrs(sTestCrs As String, oLayerProps As Collection(Of CustomWmsLayerProps)) As Boolean
    Dim bResult As Boolean = True

    For Each oWmsProps In oLayerProps
      Dim bFoundIt As Boolean = False
      For Each sCrs In oWmsProps.CrsAvailable
        If sCrs = sTestCrs Then
          bFoundIt = True
          Exit for
        End If
      Next sCrs
      If Not bFoundIt Then
        bResult = False
        Exit For
      End If
    Next oWmsProps

    Return bResult

  End Function
End Class
