﻿Imports ThinkGeo.MapSuite.Drawing
Imports ThinkGeo.MapSuite.Layers
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Styles
Imports ThinkGeo.MapSuite.WinForms

Public Class Form1
  Private moShapefile As ShapeFileFeatureLayer
  Private moWmsLayer As CustomWMSLayer

  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
    '***** Create WMS Raster layer
    moWmsLayer = New CustomWMSLayer(New Uri("https://www.mrlc.gov/geoserver/ows?SERVICE=WMS"))
        moWmsLayer.DrawingExceptionMode = DrawingExceptionMode.DrawException

        moWmsLayer.DrawingExceptionMode = DrawingExceptionMode.DrawException
    moWmsLayer.UserAgent = "Silvics Solutions, LLC"

    '***** Set Crs
    moWmsLayer.Crs = "EPSG:3857"

    '***** Srid
    Dim iSelectedSrid As Integer = 3857
    '***** Set Axis Order
    moWmsLayer.AxisOrder = ThinkGeo.MapSuite.Layers.WmsAxisOrder.XY
        moWmsLayer.ActiveLayerNames.Add("mrlc_display:NLCD_2019_Land_Cover_L48")

        moWmsLayer.Open()
        '***** Note that the service version is 1.3.0
        Debug.WriteLine("Wms version: " + moWmsLayer.GetServiceVersion)


        '***** Add Wms layer to overlay
        Dim oOverlay As New LayerOverlay
    oOverlay.Layers.Add(moWmsLayer)

        '***** Set Active layer name

        '***** Add States shapefile for reference
        Dim sPath As String = "..\..\Data\States_Albers.shp"
    moShapefile = New ShapeFileFeatureLayer(sPath, GeoFileReadWriteMode.ReadWrite)
    moShapefile.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColors.Transparent, GeoColors.Blue, 1)
    moShapefile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

        '***** Project shapefile to 3857
        Dim oProj4 As New UnmanagedProj4Projection()
        oProj4.InternalProjectionParametersString = Proj4Projection.GetEsriParametersString(102003)
        oProj4.ExternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(iSelectedSrid)
        oProj4.Open()
        moShapefile.FeatureSource.Projection = oProj4

        moShapefile.Open()

        oOverlay.Layers.Add(moShapefile)

    With WinformsMap1
      .Overlays.Add(oOverlay)
      .MapUnit = ThinkGeo.MapSuite.GeographyUnit.Meter
      .CurrentExtent = moShapefile.GetBoundingBox
      .Refresh()
    End With
  End Sub
End Class
